#include <amxmodx>
#include <hamsandwich>
#include <fakemeta>
#include <cstrike>
#include <fun>
#include <thehidden>
#include <amx_settings_api>

#define LINUX_WEAPON_OFF  4
#define LINUX_PLAYER_OFF  5
#define m_pPlayer        41

new HamHook:g_pHamForward;
new g_szKnifeModel[TH_MAXFILELENGHT], g_szModels[3][16], g_pMsgHideWeapon;
public plugin_precache()
{
// PLAYER
  new model[TH_MAXFILELENGHT];
  if(!amx_load_setting_string(TH_SETTINGSFILE, "Hidden", "PLAYER_MODEL", model, charsmax(model)))
  {
    model = "thehidden";
    amx_save_setting_string(TH_SETTINGSFILE, "Hidden", "PLAYER_MODEL", model);
  }

  formatex(g_szModels[1], charsmax(g_szModels[]), "%s", model);
  th_set_model(1, g_szModels[1]);
  format(model, charsmax(model), "models/player/%s/%s.mdl", model, model);
  precache_model(model);

  if(!amx_load_setting_string(TH_SETTINGSFILE, "IRIS", "PLAYER_MODEL", model, charsmax(model)))
  {
    model = "gign";
    amx_save_setting_string(TH_SETTINGSFILE, "IRIS", "PLAYER_MODEL", model);
  }

  formatex(g_szModels[2], charsmax(g_szModels[]), "%s", model);
  th_set_model(2, g_szModels[2]);
  format(model, charsmax(model), "models/player/%s/%s.mdl", model, model);
  precache_model(model);
// END

  if(!amx_load_setting_string(TH_SETTINGSFILE, "Hidden", "KNIFE_MODEL_V", g_szKnifeModel, charsmax(g_szKnifeModel)))
  {
    g_szKnifeModel = "models/thehidden/v_knife_hidden.mdl";
    amx_save_setting_string(TH_SETTINGSFILE, "Hidden", "KNIFE_MODEL_V", g_szKnifeModel);
  }
  precache_model(g_szKnifeModel);
}

public plugin_init()
{
  register_plugin("[TH] Replacements", TH_VERSION, TH_AUTHOR);

  register_message(get_user_msgid("TextMsg"), "Message_Block");
  register_forward(FM_GetGameDescription, "Forward_GetGameDescription_pre", 0);

  RegisterHam(Ham_Item_Deploy, "weapon_knife", "Ham_Knife_Deploy_post", 1);
  DisableHamForward((g_pHamForward = RegisterHamPlayer(Ham_TraceAttack, "Ham_TraceAttack_pre", 0)));
  set_msg_block(get_user_msgid("Money"), BLOCK_SET);
  set_msg_block((g_pMsgHideWeapon = get_user_msgid("HideWeapon")), BLOCK_SET);
}

public Ham_TraceAttack_pre()
{
  return HAM_SUPERCEDE;
}

public th_gamemode(mode)
{
  if(mode == GAME_STARTED)
  {
    DisableHamForward(g_pHamForward);
    new num, id;
    static players[32], model[20];
    get_players(players, num, "a");
    for(--num; num >= 0; num--)
    {
      id = players[num];
      give_hud(id);
      if(!user_has_weapon(id, CSW_KNIFE))
        ham_give_weapon(id, "weapon_knife");

      if(!th_get_playerdata(id, PD_HIDDEN))
      {
        cs_get_user_model(id, model, charsmax(model));
        if(!equal(model, g_szModels[2]))
        {
          // cs_reset_user_model(id);
          cs_set_user_model(id, g_szModels[2]);
        }
      }
    }
  }
  else EnableHamForward(g_pHamForward);
}

public Ham_Knife_Deploy_post(ent)
{
  new id = get_weapon_owner(ent);
  if(th_get_playerdata(id, PD_HIDDEN))
  {
    if(!is_user_bot(id))
      if(cs_get_user_shield(id))
        return;

    set_pev(id, pev_viewmodel2, g_szKnifeModel);
  }
}

public Message_Block(msgid, dest, id)
{
  if(get_msg_args() > 1)
  {
    static message[128];
    get_msg_arg_string(2, message, charsmax(message));
    if(equal(message, "#Killed_Teammate") || equal(message, "#Game_teammate_kills") || equal(message, "#Game_teammate_attack") || equal(message, "#C4_Plant_At_Bomb_Spot"))
      return PLUGIN_HANDLED;
  }

  return PLUGIN_CONTINUE;
}

public Forward_GetGameDescription_pre()
{
  forward_return(FMV_STRING, "The Hidden");
  return FMRES_SUPERCEDE;
}

public get_weapon_owner(ent)
  return get_pdata_cbase(ent, m_pPlayer, LINUX_WEAPON_OFF);

public give_hud(id)
{
  message_begin(MSG_ONE_UNRELIABLE, g_pMsgHideWeapon, _, id);
  write_byte((1<<3) + (1<<6) + (1<<7));
  message_end();
}
