#if defined _thehidden_const_included
  #endinput
#endif
#define _thehidden_const_included

#if AMXX_VERSION_NUM < 183
  #define client_print_color ColorChat
  #define print_team_default NORMAL
  #define print_team_grey GREY
  #define print_team_red RED
  #define print_team_blue BLUE
  #define print_team_green GREEN
  #include <colorchat>

  #define Ham_CS_Player_ResetMaxSpeed Ham_Item_PreFrame
  #define DMG_GRENADE (1<<24)
  stock HamHook:RegisterHamPlayer(Ham:function, const Callback[], Post=0)
    return RegisterHam(function, "player", Callback, Post);

  #if defined _fakemeta_included
    #define write_coord_f(%0) engfunc(EngFunc_WriteCoord, %0)
    stock message_begin_f(dest, msg_type, const Float:origin[3] = {0.0,0.0,0.0}, player=0)
      engfunc(EngFunc_MessageBegin, dest, msg_type, origin, player);
  #endif
#endif

#define TH_VERSION   "1.0.4"
#define TH_AUTHOR    "GuskiS"
#define TH_TAG       "^3[^4TheHidden^3]^1"

#define TH_MAXMENULENGHT 64
#define TH_MAXFILELENGHT 64
#define TH_SETTINGSFILE  "th_mod.ini"
#define TH_CONFIGFILE    "th_mod.cfg"

#pragma semicolon 1

enum _:GAME_STATE
{
  GAME_UNSET,
  GAME_OFF,
  GAME_PREPARING,
  GAME_RESTARTING,
  GAME_STARTED,
  GAME_ENDED
}

enum _:PLAYER_DATA
{
  PD_HIDDEN,    // Is hidden?
  PD_ONWALL,    // Is on wall?
  PD_JUMPING,   // Is jumping?
  PD_DELAYED    // Knife entity that should be delayed
}

enum _:GLOBAL_INFO
{
  GI_HIDDEN,    // Current Hidden user id
  GI_NEXTHIDDEN // Next Hidden user id
}
