#include <amxmodx>
#include <engine>
#include <thehidden>

public plugin_precache()
{
  new map[32];
  get_mapname(map, charsmax(map));
  strtolower(map);
  if(equal(map, "cs_assault_mini"))
  {
    create_wall_block(Float:{-191.50, 1017.50, 349.50}, Float:{-20.50, -53.50, -29.50}, Float:{20.50, 53.50, 29.50});
    create_wall_block(Float:{461.50, 983.50, 359.50}, Float:{-2.50, -19.50, -19.50}, Float:{2.50, 19.50, 19.50});
    create_wall_block(Float:{247.50, 947.00, 359.50}, Float:{-19.50, -15.00, -19.50}, Float:{19.50, 15.00, 19.50});
  }
}

public plugin_init()
{
  register_plugin("[TH] Map support", TH_VERSION, TH_AUTHOR);
}

stock create_wall_block(const Float:origin[3], const Float:mins[3], const Float:maxs[3])
{
  new ent = create_entity("info_target");
  if(ent)
  {
    entity_set_string(ent, EV_SZ_classname, "wall_block_ent");
    static model[64];
    th_get_model(2, model);
    format(model, charsmax(model), "models/player/%s/%s.mdl", model, model);
    entity_set_model(ent, model);
    entity_set_size(ent, mins, maxs);

    entity_set_int(ent, EV_INT_solid, SOLID_BBOX);
    entity_set_int(ent, EV_INT_movetype, MOVETYPE_NONE);
    entity_set_origin(ent, origin);

    return ent;
  }

  return 0;
}
